execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},scores={flash-toggle=1}] at @s run function mbfp:carrot_items/flashlight/flashraycaststart

execute as @e[tag=flashlight] at @s if entity @a[tag=flashlight-on,nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] run fill ~5 ~5 ~5 ~-5 ~-5 ~-5 air replace light 

#Wyświetlanie wiadomości
execute as @a[scores={flash-toggle=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] run execute at @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] run title @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] actionbar ["",{"text":"Press \"","color":"gray"},{"text":"Right Click","bold":true,"color":"yellow"},{"text":"\" to turn on / off","color":"gray"}]

#włączanie latary
execute unless entity @a[tag=flashlight-on,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},scores={flash-toggle=1}] as @e[tag=flashlight] at @s unless block ~ ~ ~ light run function mbfp:carrot_items/flashlight/flashlight
execute if entity @a[tag=flashlight-on,nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] as @e[tag=flashlight] at @s run function flashlight:lightdelete

#sprawdza czy gracz ma latare w lapie
execute if entity @a[tag=flashlight-on,scores={flash-toggle=..0}] as @e[tag=flashlight] at @s run function mbfp:carrot_items/flashlight/lightdelete

execute as @a[tag=!flashlight-on,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}}] if entity @s[scores={flash-toggle=1}] run function mbfp:carrot_items/flashlight/flashraycaststart
execute as @a[tag=!flashlight-on,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},scores={flash-toggle=1}] at @s run tag @s add flashlight-on
execute as @a[nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},scores={flash-toggle=1}] run scoreboard players set @s flash-toggle 0
execute as @a[tag=flashlight-on,scores={flash-toggle=0}] run tag @s remove flashlight-on

#zamiana modelu latary na włączony
execute as @a[scores={flash-toggle=1}] run item replace entity @s weapon with carrot_on_a_stick{CustomModelData:26,flashlight:1,display:{Name:'[{"text":"Flashlight","italic":false}]',Lore:['[{"text":"Tools","italic":false,"color":"gray"}]']}}

#wyłączanie latary
execute as @a[nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},tag=flashlight-on] run tag @s remove flashlight-on
execute as @a[scores={flash-toggle=2..}] at @s run playsound ui.button.click master @s ~ ~ ~ 1 1.5
execute as @a[scores={flash-toggle=2..}] run scoreboard players set @s flash-toggle -1

#zamiana modelu latary na wyłączony
execute as @a[scores={flash-toggle=-1}] run item replace entity @s weapon with carrot_on_a_stick{CustomModelData:25,flashlight:1,display:{Name:'[{"text":"Flashlight","italic":false}]',Lore:['[{"text":"Tools","italic":false,"color":"gray"}]']}}

#wyłączanie latary dalsza część
execute as @a[nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{flashlight:1}}},scores={flash-toggle=..-1}] at @s run fill ~15 ~15 ~15 ~-15 ~-15 ~-15 air replace light
execute as @a[scores={flash-toggle=..-1}] at @s run fill ~15 ~15 ~15 ~-15 ~-15 ~-15 air replace light
execute as @a[scores={flash-toggle=-1}] run scoreboard players set @s flash-toggle 0
execute as @e[tag=flashlight] at @s run function mbfp:carrot_items/flashlight/flashlight

#czyści tablice po kliknięciu karoty na kiju
execute as @a[scores={items_carrot_stick=1..},nbt={SelectedItem:{tag:{flashlight:1}}}] run scoreboard players set @a[scores={items_carrot_stick=1..},nbt={SelectedItem:{tag:{flashlight:1}}}] items_carrot_stick 0

#sprawdza czy gracz nie ma latary w lapie i wylacza w niej światło
execute if entity @a[scores={flash-toggle=..0}] run execute as @e[tag=flashlight] run execute at @s run function mbfp:carrot_items/flashlight/lightdelete

schedule function mbfp:carrot_items/flashlight/flashlight-tick 1t